# LatticeRules

| **Documentation** | **Build Status** | **Coverage** |
|-------------------|------------------|--------------|
| [![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://PieterjanRobbe.github.io/LatticeRules.jl/stable) [![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://PieterjanRobbe.github.io/LatticeRules.jl/dev) | [![Build Status](https://github.com/PieterjanRobbe/LatticeRules.jl/workflows/CI/badge.svg)](https://github.com/PieterjanRobbe/LatticeRules.jl/actions) [![Build Status](https://travis-ci.com/PieterjanRobbe/LatticeRules.jl.svg?branch=master)](https://travis-ci.com/PieterjanRobbe/LatticeRules.jl) [![Build Status](https://ci.appveyor.com/api/projects/status/github/PieterjanRobbe/LatticeRules.jl?svg=true)](https://ci.appveyor.com/project/PieterjanRobbe/LatticeRules-jl) | [![Coverage](https://codecov.io/gh/PieterjanRobbe/LatticeRules.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/PieterjanRobbe/LatticeRules.jl) [![Coverage](https://coveralls.io/repos/github/PieterjanRobbe/LatticeRules.jl/badge.svg?branch=master)](https://coveralls.io/github/PieterjanRobbe/LatticeRules.jl?branch=master) |

This module provides an implementation of rank-1 lattice rules. Lattice rules generate "quasi-random" sequences of points in `d` dimensions which are equally distributed over the `d`-dimensional unit cube [0,1]<sup>d</sup>.

## Usage

To initialize a rank-1 lattice rule `lattice_rule` in `d` dimensions, use
```julia
using LatticeRules
my_lattice = LatticeRule(d)
``` 

Then
```julia
getpoint(my_lattice, 0)
```
or
```julia
my_lattice[0]
```
returns the first point of the lattice, and 
```julia
my_lattice[k]
```
returns the `k`th point of the lattice. 

For a `d`-dimensional function `f`,
```julia
f.(my_lattice[1:N])
```
gives an approximation for the integral of `f` using `N` lattice points.

Providing your own generating vector `z` is possible with
```julia
my_other_lattice = LatticeRule(z, d, n)
```
where `n` is the maximum number of points in the lattice.

In practice, it is more useful to have a shifted rank-1 lattice rule
```julia
my_shifted_lattice = ShiftedLatticeRule(d)
```
to obtain an error estimate in the same way as in the Monte Carlo method.

An existing lattice rule can be turned into a randomly shifted lattice rule using
```julia
my_other_shifted_lattice = ShiftedLatticeRule(my_lattice)
```
or
```julia
shift = rand(ndims(my_lattice)) 
my_final_shifted_lattice = ShiftedLatticeRule(my_lattice, shift)
```
optionally providing the random shift vector `shift`.

More extensive documentation can be found [here](https://PieterjanRobbe.github.io/LatticeRules.jl/dev).

## Example

A classic toy example to illustrate the Monte Carlo method is to approximate the value of &pi; by throwing random darts on a square board. Suppose we draw a circle on the board with a diameter equal to the length of one side of the square. Then, the ratio of the area of the circle to the area of the square is &pi;/4. If we now repeatedly throw darts at random on the board, the ratio of the number of darts that landed inside the circle and the total number of darts, multiplied by 4, is an approximation to &pi;.

First, generate a lattice rule in two dimensions.
```julia
using LatticeRules, Statistics
my_lattice = LatticeRule(2)
```

The function `inside_circle` checks if a dart is inside the circle:
```julia
inside_circle(x) = x[1]*x[1] + x[2]*x[2] < 1
```

Our approximation for the value of &pi; is
```
Q = 4 * mean(inside_circle.(collect(my_lattice)))
``` 
with `Q = 3.1416015625`.

## See also

- [The "Magic Point Shop" of QMC point generators and generating vectors](https://people.cs.kuleuven.be/~dirk.nuyens/qmc-generators/) by D. Nuyens
- [Lattice rule generating vectors](https://web.maths.unsw.edu.au/~fkuo/lattice/index.html) by F. Y. Kuo.

# default generating vector files
const K_3600_32_file = joinpath(@__DIR__(), "..", "generating_vectors", "K_3600_32.txt")
const CKN_250_20_file = joinpath(@__DIR__(), "..", "generating_vectors", "CKN_250_20.txt")

# re-compile if these files change
include_dependency(K_3600_32_file)
include_dependency(CKN_250_20_file)

# default generating vectors
const K_3600_32 = read32(K_3600_32_file)
const CKN_250_20 = read32(CKN_250_20_file)

module LatticeRules

import Random

export AbstractLatticeRule, LatticeRule, LatticeRule32, ShiftedLatticeRule, ShiftedLatticeRule32, getpoint, unsafe_getpoint, unsafe_getpoint!, ndims, length

export K_3600_32, K_3600_32_file, CKN_250_20, CKN_250_20_file # from lattice_data.jl

for file in ["common", "lattice_data", "LatticeRule32", "ShiftedLatticeRule32"]
    include(string(file, ".jl"))
end

end # module

#
# LatticeRule32
#
struct LatticeRule32{s} <: AbstractLatticeRule{s}
    z::Vector{UInt32} # generating vector
    n::Int64 # max number of points in the lattice rule
end

# default lattice rule type
const LatticeRule = LatticeRule32

# access max number of points in the lattice
Base.length(lattice_rule::LatticeRule32) = lattice_rule.n

# uinttype
uinttype(::LatticeRule32) = UInt32

"""
    LatticeRule32(z, s, n)
    LatticeRule32(z, s)
    LatticeRule32(z)

Returns a rank-1 lattice rule in `s` dimensions with generating vector `z` and at most `n` points.

When no maximum number of points `n` is provided, we assume `n = typemax(UInt32) = 2^32 - 1`. When no number of dimensions `s` is provided, we assume `s = length(z)`. 

!!! info

    Technically, we return an extensible lattice sequence where the `k`-th point is transformed using the gray coded radical inverse function. This has the advantage that we can add points to the lattice without changing the already computed points.

More generating vectors can be found online [here](https://web.maths.unsw.edu.au/~fkuo/lattice/index.html) or [here](https://people.cs.kuleuven.be/~dirk.nuyens/qmc-generators/).

# Examples
```jldoctest; setup = :(using LatticeRules; import Random; Random.seed!(1))
julia> lattice_rule = LatticeRule32([UInt32(1), UInt32(5)], 2, 8) # Fibonacci lattice
LatticeRule32{2}

julia> getpoint(lattice_rule, 2)
2-element Array{Float64,1}:
 0.25
 0.25

```
See also: [`getpoint`](@ref), [`ShiftedLatticeRule32`](@ref)
"""
LatticeRule32(z::Vector{UInt32}) = LatticeRule32(z, length(z)) # specify generating vector

# specify generating vector and number of dimensions
LatticeRule32(z::Vector{UInt32}, s::Integer) = LatticeRule32(z, s, typemax(UInt32) + 1)

# specify generating vector, number of dimensions and maximum number of points
function LatticeRule32(z::Vector{UInt32}, s::Integer, n::Integer)
    s > 0 || throw(ArgumentError("number of dimensions s must be larger than 0"))
    s ≤ length(z) || throw(ArgumentError("number of dimensions s must be less than or equal to the length of the generating vector z"))
    n > 0 || throw(ArgumentError("maximum number of points n must be larger than 0"))
    n ≤ typemax(UInt32) + 1 || throw(ArgumentError("maximum number of points n must be less than or equal to 2^32, consider implementing a LatticeRule64 type"))
    LatticeRule32{s}(view(z, 1:s), n)
end

"""
    LatticeRule32(file, s, n)
    LatticeRule32(file, s)
    LatticeRule32(file)

Returns a rank-1 lattice rule in `s` dimensions with generating vector `z` read from the file `file` and with at most `n` points.

# Examples
```jldoctest; setup = :(using LatticeRules)
julia> z_file = K_3600_32_file;

julia> lattice_rule = LatticeRule32(z_file, 16)
LatticeRule32{16}

julia> getpoint(lattice_rule, 123)
16-element Array{Float64,1}:
 0.8671875
 0.9609375
 0.6015625
 0.8984375
 0.6484375
 0.6328125
 0.3203125
 0.2890625
 0.0234375
 0.1015625
 0.7890625
 0.0703125
 0.6953125
 0.0234375
 0.1171875
 0.0859375

```
See also: [`getpoint`](@ref), [`ShiftedLatticeRule32`](@ref)
"""
LatticeRule32(file::AbstractString) = LatticeRule32(read32(file)) # specify file containing generating vector

# specify file containting generating vector and number of dimensions
LatticeRule32(file::AbstractString, s::Integer) = LatticeRule32(read32(file), s)

# specify file containing generating vector, number of dimensions and maximum number of points
LatticeRule32(file::AbstractString, s::Integer, n::Integer) = LatticeRule32(read32(file), s, n)

"""
    LatticeRule32(s)

Returns a rank-1 lattice rule in `s` dimensions that uses a default generating vector with order-2 weights.

# Examples
```jldoctest; setup = :(using LatticeRules)
julia> lattice_rule = LatticeRule32(16)
LatticeRule32{16}

julia> getpoint(lattice_rule, 123)
16-element Array{Float64,1}:
 0.8671875
 0.5390625
 0.6015625
 0.3671875
 0.6796875
 0.8203125
 0.3046875
 0.8515625
 0.7109375
 0.6328125
 0.5703125
 0.2578125
 0.6953125
 0.0390625
 0.2421875
 0.4453125

```
See also: [`getpoint`](@ref), [`ShiftedLatticeRule32`](@ref)
"""
function LatticeRule32(s::Integer) # specify number of dimensions only
    s ≤ 3600 || throw(ArgumentError("number of dimensions s must be less than or equal to 3600, please supply your own generating vector z"))
    s ≤ 250 ? LatticeRule32(CKN_250_20, s, 2^20) : LatticeRule32(K_3600_32, s)
end

# in-place version of unsafe_getpoint (with 0 memory allocations)
@inline function unsafe_getpoint!(x::Vector{<:AbstractFloat}, lattice_rule::LatticeRule32, k::UInt32)
    ϕ_k = reversebits(k) * 2.0^(-32) # gray coded radical inverse function in base 2
    @inbounds for i in 1:length(x)
        x[i] = ϕ_k * lattice_rule.z[i]
        x[i] -= floor(x[i]) # mod 1
    end
    x
end

# fancy printing
Base.show(io::IO, lattice_rule::LatticeRule32{s}) where s = print(io, string("LatticeRule32{", s, "}"))

using LatticeRules, SpecialFunctions, Statistics, Test

@testset "LatticeRules" begin

    @testset "Constructing LatticeRule" begin

        # test constructor with generating vector, number of dimensions and max number of points
        @testset "LatticeRule(z, s, n)" begin
            lattice_rule = LatticeRule([UInt32(1), UInt32(5)], 2, 8)
            @test ndims(lattice_rule) == 2
            @test length(lattice_rule) == 8
            @test size(lattice_rule) == (8,)
        end

        # test constructor with generating vector and number of dimensions
        @testset "LatticeRule(z, s)" begin
            lattice_rule = LatticeRule(K_3600_32, 16)
            @test ndims(lattice_rule) == 16
            @test length(lattice_rule) == 2^32
        end

        # test constructor with generating vector only
        @testset "LatticeRule(z)" begin
            lattice_rule = LatticeRule(K_3600_32, 250)
            @test ndims(lattice_rule) == 250
            @test length(lattice_rule) == 2^32
        end

        # test constructor with number of dimensions only
        @testset "LatticeRule(s)" begin
            lattice_rule = LatticeRule(251)
            @test ndims(lattice_rule) == 251
            @test length(lattice_rule) == 2^32
        end

        # test constructor with file containing generating vector, number of dimensions and max number of points
        @testset "LatticeRule(z_file, s, n)" begin
            lattice_rule = LatticeRule(CKN_250_20_file, 9, 2^20)
            @test ndims(lattice_rule) == 9
            @test length(lattice_rule) == 2^20
        end

        # test constructor with file containing generating vector and number of dimensions
        @testset "LatticeRule(z_file, s)" begin
            lattice_rule = LatticeRule(K_3600_32_file, 16)
            @test ndims(lattice_rule) == 16
            @test length(lattice_rule) == 2^32
        end

        # test constructor with file containing generating vector only
        @testset "LatticeRule(z_file)" begin
            lattice_rule = LatticeRule(K_3600_32_file)
            @test ndims(lattice_rule) == 3600
            @test length(lattice_rule) == 2^32
        end

        # test getpoint
        @testset "getpoint(lattice_rule, k)" begin
            lattice_rule = LatticeRule(10)
            point0 = getpoint(lattice_rule, 0)
            @inferred getpoint(lattice_rule, 10)
            @test point0 isa eltype(LatticeRule)
            @test sum(point0) == 0
        end

        # test iterator access
        @testset "iterate(lattice_rule, state)" begin
            lattice_rule = LatticeRule(32)
            for i in lattice_rule
                nothing
            end
            @test all(first(lattice_rule) .== lattice_rule[0])
        end

        # test lattice_rule[i] access
        @testset "lattice_rule[i]" begin
            lattice_rule = LatticeRule(2)
            @test length(lattice_rule[0]) == 2
            @inferred lattice_rule[100]
            @test length(lattice_rule[end]) == 2
            @test firstindex(lattice_rule) == 0
            @test length(lattice_rule[1:20]) == 20
            @test length(collect(lattice_rule)) == 2^20
        end

        # test error handling
        @testset "error handling" begin
            lattice_rule = LatticeRule(9)
            @test_throws BoundsError getpoint(lattice_rule, -1)
            @test_throws BoundsError getpoint(lattice_rule, 2^20)
            @test_throws ArgumentError LatticeRule(0)
            @test_throws ArgumentError LatticeRule(-1)
            @test_throws ArgumentError LatticeRule(3601)
            @test_throws ArgumentError LatticeRule(CKN_250_20, 251)
            @test_throws ArgumentError LatticeRule(CKN_250_20_file, 12 ,0)
            @test_throws ArgumentError LatticeRule(K_3600_32, 251, 2^32 + 1)
        end

        # test print method
        @testset "show(lattice_rule)" begin
            lattice_rule = LatticeRule(9)
            str = string(lattice_rule)
        end

    end

    @testset "Constructing ShiftedLatticeRule" begin

        # test constructor with lattice rule and random shift
        @testset "ShiftedLatticeRule(lattice_rule, Δ)" begin
            lattice_rule = LatticeRule([UInt32(1), UInt32(5)], 2, 8)
            shifted_lattice_rule = ShiftedLatticeRule(lattice_rule, rand(2))
            @test ndims(shifted_lattice_rule) == 2
            @test length(shifted_lattice_rule) == 8
        end

        # test constructor with lattice rule only
        @testset "ShiftedLatticeRule(lattice_rule)" begin
            lattice_rule = LatticeRule([UInt32(1), UInt32(5)], 2, 8)
            shifted_lattice_rule = ShiftedLatticeRule(lattice_rule)
            @test ndims(shifted_lattice_rule) == 2
            @test length(shifted_lattice_rule) == 8
        end

        # test constructor with number of dimensions only
        @testset "ShiftedLatticeRule(s)" begin
            shifted_lattice_rule = ShiftedLatticeRule(251)
            @test ndims(shifted_lattice_rule) == 251
            @test length(shifted_lattice_rule) == 2^32
        end

        # test getpoint
        @testset "getpoint(shifted_lattice_rule, k)" begin
            shifted_lattice_rule = ShiftedLatticeRule(10)
            point0 = getpoint(shifted_lattice_rule, 0)
            @test point0 isa eltype(ShiftedLatticeRule)
            @inferred getpoint(shifted_lattice_rule, 101)
            @test all(0 .≤ point0 .≤ 1)
        end

        # test error handling
        @testset "error handling" begin
            lattice_rule = LatticeRule(100)
            @test_throws DimensionMismatch ShiftedLatticeRule(lattice_rule, rand(101))
            @test_throws ArgumentError ShiftedLatticeRule(lattice_rule, rand(100) .- 1)
            @test_throws ArgumentError ShiftedLatticeRule(lattice_rule, rand(100) .+ 1)
        end

        # test print method
        @testset "show(shifted_lattice_rule)" begin
            shifted_lattice_rule = ShiftedLatticeRule(9)
            str = string(shifted_lattice_rule)
        end

    end

    # approximate pi by throwing random darts in a square
    @testset "Approximating pi by throwing darts" begin
        darts(x) = x[1]*x[1] + x[2]*x[2] < 1
        lattice_rule = LatticeRule(2)
        Q = 4 * mean(darts.(collect(lattice_rule)))
        @test Q ≈ π rtol=1e-5
    end

    # see Keister, Bradley D. "Multidimensional quadrature algorithms." Computers in Physics 10.2 (1996): 119-128.
    @testset "Computing multidimensional integral from Keister, Bradley" begin
        dims = [9, 25, 60, 80, 100]
        exact = [-71.633234291 -1.356914e6 4.89052986e14 6.78878724e19 4.57024396e24]
        f(x) = cos(sqrt(sum(erfinv.(2*x .- 1).^2)))
        for (d, I) in Iterators.zip(dims, exact)
            lattice_rule = ShiftedLatticeRule(d)
            Q = π^(d/2) * mean(f.(collect(lattice_rule)))
            @test Q ≈ I rtol=1e-3
        end
    end

end

#
# AbstractLatticeRule
#
abstract type AbstractLatticeRule{s} <: Random.AbstractRNG end

# number of dimensions
Base.ndims(::AbstractLatticeRule{s}) where s = s::Int

# size
Base.size(lattice_rule::AbstractLatticeRule) = (length(lattice_rule), )

# reverse bits (https://graphics.stanford.edu/~seander/bithacks.html#ReverseParallel)
reversebits(u::UInt32) = begin
    u = ((u >> 1) & 0x55555555) | ((u & 0x55555555) << 1)
    u = ((u >> 2) & 0x33333333) | ((u & 0x33333333) << 2)
    u = ((u >> 4) & 0x0F0F0F0F) | ((u & 0x0F0F0F0F) << 4)
    u = ((u >> 8) & 0x00FF00FF) | ((u & 0x00FF00FF) << 8)
    u = ( u >> 16             ) | ( u               << 16)
end

# read contents of file containing a generating vector and convert it to a Vector of UInt32's
read32(file::AbstractString) = parse.(UInt32, readlines(file))

"""
    getpoint(lattice_rule, k)

Get the `k`-th point of the lattice rule `lattice_rule`.

!!! note

    An alternative syntax is `getindex(lattice_rule, k)` or `lattice_rule[k]`, this allows you to write the one-liner `Q = mean(f.(lattice_rule[0:N-1]))` for the quasi-Monte Carlo estimator for ``E[f]``.

```jldoctest; setup = :(using LatticeRules)
julia> lattice_rule = LatticeRule32(2)
LatticeRule32{2}

julia> getpoint(lattice_rule, 3)
2-element Array{Float64,1}:
 0.75
 0.25

```
See also: [`LatticeRule32`](@ref), [`ShiftedLatticeRule32`](@ref)
"""
@inline function getpoint(lattice_rule::AbstractLatticeRule, k::Number) # get the k-th point of the lattice sequence
    0 ≤ k < length(lattice_rule) || throw(BoundsError(lattice_rule, k))
    unsafe_getpoint(lattice_rule, convert(uinttype(lattice_rule), k))
end

# get the k-th point of the sequence without bounds checking for 32 bit integers
@inline unsafe_getpoint(lattice_rule::AbstractLatticeRule{s}, k::UInt32) where s = begin
    x = Vector{Float64}(undef, s)
    unsafe_getpoint!(x, lattice_rule, k) # dispatch to AbstractLatticeRule subtype
end

# make LatticeRule iterable
Base.iterate(lattice_rule::AbstractLatticeRule, state=uinttype(lattice_rule)(0)) = state ≥ length(lattice_rule) ? nothing : (getpoint(lattice_rule, state), state + uinttype(lattice_rule)(1))
Base.eltype(::Type{<:AbstractLatticeRule}) = Vector{Float64}

# enable lattice_rule[i] access
Base.getindex(lattice_rule::AbstractLatticeRule, i::Number) = getpoint(lattice_rule, i)
Base.getindex(lattice_rule::AbstractLatticeRule, I) = [lattice_rule[i] for i in I]
Base.firstindex(lattice_rule::AbstractLatticeRule) = uinttype(lattice_rule)(0)
Base.lastindex(lattice_rule::AbstractLatticeRule) = uinttype(lattice_rule)(length(lattice_rule) - 1)

#
# ShiftedLatticeRule32
#
struct ShiftedLatticeRule32{s, L, V} <: AbstractLatticeRule{s}
    lattice_rule::L
    Δ::V
end

# default shifted lattice rule type
const ShiftedLatticeRule = ShiftedLatticeRule32

# access max number of points in the lattice
Base.length(shifted_lattice_rule::ShiftedLatticeRule32) = length(shifted_lattice_rule.lattice_rule)

# uinttype
uinttype(::ShiftedLatticeRule32) = UInt32

"""
    ShiftedLatticeRule32(lattice_rule)
    ShiftedLatticeRule32(lattice_rule, shift)

Returns a shifted rank-1 lattice rule based on the lattice rule `lattice_rule` using the random shift `shift`. If no random shift is provided, we use `shift = rand(length(lattice_rule))`.

# Examples
```jldoctest; setup = :(using LatticeRules; import Random; Random.seed!(1))
julia> lattice_rule = LatticeRule32(16)
LatticeRule32{16}

julia> shifted_lattice_rule = ShiftedLatticeRule32(lattice_rule)
ShiftedLatticeRule32{16}

julia> getpoint(shifted_lattice_rule, 0)
16-element Array{Float64,1}:
 0.23603334566204692
 0.34651701419196046
 0.3127069683360675
 0.00790928339056074
 0.4886128300795012
 0.21096820215853596
 0.951916339835734
 0.9999046588986136
 0.25166218303197185
 0.9866663668987996
 0.5557510873245723
 0.43710797460962514
 0.42471785049513144
 0.773223048457377
 0.2811902322857298
 0.20947237319807077

```
See also: [`LatticeRule32`](@ref), [`getpoint`](@ref)
"""
ShiftedLatticeRule32(lattice_rule::LatticeRule32{s}) where s = ShiftedLatticeRule32(lattice_rule, rand(s)) # specify lattice rule

# specify lattice rule and random shift
function ShiftedLatticeRule32(lattice_rule::LatticeRule32{s}, Δ::Vector{<:AbstractFloat}) where s
    length(Δ) == ndims(lattice_rule) || throw(DimensionMismatch("length of the random shift vector must be equal to the number of dimensions of the lattice rule, expected $(ndims(lattice_rule)), got $(length(Δ))"))
    all(0 .≤ Δ .≤ 1) || throw(ArgumentError("random shift vector must contain uniformly distributed random numbers"))
    ShiftedLatticeRule32{s, typeof(lattice_rule), typeof(Δ)}(lattice_rule, Δ)
end

"""
    ShiftedLatticeRule32(s)

Returns a shifted rank-1 lattice rule in `s` dimensions that uses a default generating vector with order-2 weights and a randomly generated shift vector.

# Examples
```jldoctest; setup = :(using LatticeRules; import Random; Random.seed!(1))
julia> shifted_lattice_rule = ShiftedLatticeRule32(16)
ShiftedLatticeRule32{16}

julia> shifted_lattice_rule[0]
16-element Array{Float64,1}:
 0.23603334566204692
 0.34651701419196046
 0.3127069683360675
 0.00790928339056074
 0.4886128300795012
 0.21096820215853596
 0.951916339835734
 0.9999046588986136
 0.25166218303197185
 0.9866663668987996
 0.5557510873245723
 0.43710797460962514
 0.42471785049513144
 0.773223048457377
 0.2811902322857298
 0.20947237319807077

```
See also: [`getpoint`](@ref), [`ShiftedLatticeRule32`](@ref)
"""
ShiftedLatticeRule32(s::Integer) = ShiftedLatticeRule32(LatticeRule32(s)) # specify number of dimensions only

# in-place version of unsafe_getpoint (with 0 memory allocations)
@inline function unsafe_getpoint!(x::Vector{<:AbstractFloat}, shifted_lattice_rule::ShiftedLatticeRule32, k::UInt32)
    ϕ_k = reversebits(k) * 2.0^(-32) # gray coded radical inverse function in base 2
    @inbounds for i in 1:length(x)
        x[i] = ϕ_k * shifted_lattice_rule.lattice_rule.z[i] + shifted_lattice_rule.Δ[i]
        x[i] -= floor(x[i]) # mod 1
    end
    x
end

# fancy printing
Base.show(io::IO, shifted_lattice_rule::ShiftedLatticeRule32{s}) where s = print(io, string("ShiftedLatticeRule32{", s, "}"))
